#include "univers.h"
#include <iostream>
#include "ftd2xx.h"

using namespace std;

univers::univers()
{
    tab_canaux = new unsigned char[513];
    for (int i=0; i<513; i++) tab_canaux[i]=0;
}

univers::~univers()
{
   // for (int i=0; i<513; i++) tab_canaux[i]=0;
    delete [] tab_canaux;
    //cout<<"Le destructeur fait sont travail"<<endl;
}

void univers:: set_valeur(const int& num_canal, const unsigned char& valeur)
{
    tab_canaux[num_canal]=valeur;
}

unsigned char univers:: get_valeur(const int& num_canal)
{
    return tab_canaux[num_canal];
}

void univers::reset_canaux()
{
    for (int i=0; i<513; i++) tab_canaux[i]=0;
}

void univers::ToutA1()
{
    for (int i=0; i<513; i++) tab_canaux[i]=255;
}

//   univ1->transfert_ftdi(6, univ1->tab_canaux, DMX_DATA_LENGTH, ftHandle0);

//void univers::transfert_ftdi(int label, unsigned char *data, int length, FT_HANDLE& ftHandle0)
int univers::transfert_ftdi(int label, int length, FT_HANDLE& ftHandle0)
{
    #define ONE_BYTE	1
    #define DMX_START_CODE 0x7E
    #define DMX_END_CODE 0xE7
    #define DMX_HEADER_LENGTH 4
    #define OFFSET 0xFF
    #define BYTE_LENGTH 8
    #define NO_RESPONSE 0

    unsigned char end_code = DMX_END_CODE;
    FT_STATUS res = 0;
    DWORD bytes_to_write = length;
    DWORD bytes_written = 0;
    HANDLE event = NULL;
    int size=0;
    // Form Packet Header
    unsigned char header[DMX_HEADER_LENGTH];
    header[0] = DMX_START_CODE;
    header[1] = label;
    header[2] = length & OFFSET;
    header[3] = length >> BYTE_LENGTH;
    // Write The Header
    res = FT_Write(	ftHandle0,(unsigned char *)header,DMX_HEADER_LENGTH,&bytes_written);
//    if (bytes_written != DMX_HEADER_LENGTH) return  5;
//    else return 6;
//    if (bytes_written != DMX_HEADER_LENGTH) return  NO_RESPONSE;
    // Write The Data
    res = FT_Write(	ftHandle0,(unsigned char *)this->tab_canaux,length,&bytes_written);
//    if (bytes_written != length) return  5;
//    else return 6;
    // Write End Code
    res = FT_Write(	ftHandle0,(unsigned char *)&end_code,ONE_BYTE,&bytes_written);
    /*if (bytes_written != ONE_BYTE) return  NO_RESPONSE;
    if (res == FT_OK)
        return TRUE;
    else
        return FALSE;*/
}
